(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
  typeof define === 'function' && define.amd ? define(factory) :
  (global = global || self, global.docuteDemoCode = factory());
}(this, function () { 'use strict';

  function stripDemoBlock(text) {
    return text.replace(/:::demo\s*([\s\S]*):::/, '$1');
  }
  function parseComponent(text) {
    var component = stripDemoBlock(text).replace(/```html([\s\S]*)\s*```/, '$1');
    var JS_RE = /<(script)>([\s\S]*)<\/\1>/;
    var ESM_SCRIPT_RE = /<(script)>\s*export\s*default\s*{\s*([\s\S]*)}\s*<\/\1>/;
    var _a = (component.match(JS_RE) || [])[0],
        matchedScript = _a === void 0 ? '' : _a;
    var template = component.replace(JS_RE, '');
    var script = matchedScript.replace(ESM_SCRIPT_RE, '$2');
    return {
      template: template,
      script: script
    };
  }
  function registerComponent(_a, id) {
    var template = _a.template,
        script = _a.script;
    if (!Vue) return;
    var resolveComponent = new Function("return {template: `<section>" + template + "</section>`," + script + "}");
    Vue.component("demo-" + id, resolveComponent());
  }

  function parser (text) {
    var startTag = ':::demo';
    var startTagLen = startTag.length;
    var endTag = ':::';
    var endTagLen = endTag.length;
    var id = 0;
    var start = 0;
    var outputString = text;
    var demoStart = text.indexOf(startTag);
    var demoEnd = text.indexOf(endTag, demoStart + startTagLen) + endTagLen;

    while (demoStart !== -1 && demoEnd !== -1) {
      var demo = text.slice(demoStart, demoEnd);
      var parsed = parseComponent(demo);
      registerComponent(parsed, id);
      outputString = outputString.replace(demo, "<demo-" + id + "/>\n\n" + stripDemoBlock(demo));
      id++;
      start = demoEnd;
      demoStart = text.indexOf(startTag, start);
      demoEnd = text.indexOf(endTag, demoStart + startTagLen) + endTagLen;
    }

    return outputString;
  }

  function docuteDemoCode() {
    return {
      name: 'docute-plugin-demo-code',
      extend: function extend(api) {
        return api.processMarkdown(parser);
      }
    };
  }

  return docuteDemoCode;

}));
